'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _events = require('events');

var _events2 = _interopRequireDefault(_events);

var _Patterns = require('./Patterns');

var _Patterns2 = _interopRequireDefault(_Patterns);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Ely = function () {
  function Ely() {
    _classCallCheck(this, Ely);
  }

  _createClass(Ely, null, [{
    key: 'mapIn',
    value: function mapIn(object) {
      var patterns = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : undefined;

      return Ely.map(object, true, patterns);
    }
  }, {
    key: 'mapOut',
    value: function mapOut(object) {
      var patterns = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : undefined;

      return Ely.map(object, false, patterns);
    }
  }, {
    key: 'map',
    value: function map(object) {
      var embed = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;
      var patterns = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : undefined;

      var defaultPatterns = Ely.defaultPatterns;
      patterns = patterns === undefined ? defaultPatterns : patterns;

      var emitter = void 0;

      if (embed) {
        if (object.ely !== undefined) {
          if (object.ely instanceof _events2.default) {
            emitter = object.ely;
          } else {
            embed = false;
          }
        }
      }

      if (emitter === undefined) {
        emitter = new _events2.default();
      }

      if (embed && object.ely === undefined) {
        Object.defineProperty(object, 'ely', {
          configurable: true,
          enumerable: true,
          writable: false,
          value: emitter
        });
      }

      var elyMapped = object['__ely__map__'] !== undefined ? object['__ely__map__'] : {};
      var elyMappedKeys = Object.keys(elyMapped);
      elyMappedKeys.push('__ely__map__');

      var emitall = patterns !== undefined ? patterns.emitall : false;

      Object.keys(object).forEach(function (key) {
        if (elyMappedKeys.indexOf(key) === -1) {
          var descriptor = Object.getOwnPropertyDescriptor(object, key);
          if (descriptor.writable) {
            var valueType = _typeof(descriptor.value);
            if (valueType !== 'function') {
              if (patterns === undefined || Ely.match(key, patterns.accept) && Ely.notmatch(key, patterns.skip)) {
                var privateKey = Ely.findEmptyKey(object, key, '_');
                var value = object[key];

                delete object[key];
                Object.defineProperty(object, privateKey, {
                  configurable: true,
                  enumerable: true,
                  writable: true,
                  value: value
                });
                Object.defineProperty(object, key, {
                  configurable: true,
                  enumerable: true,
                  set: function set(value) {
                    emitter.emit(key, value, object[privateKey]);
                    if (emitall) {
                      emitter.emit('*', value, object[privateKey], key);
                    }
                    object[privateKey] = value;
                  },
                  get: function get() {
                    return object[privateKey];
                  }
                });

                elyMapped[privateKey] = key;
              }
            }
          }
        }
      });

      Object.defineProperty(object, '__ely__map__', {
        configurable: true,
        enumerable: false,
        writable: true,
        value: elyMapped
      });

      return emitter;
    }
  }, {
    key: 'findEmptyKey',
    value: function findEmptyKey(object, key, prefix) {
      var name = prefix + key;
      while (object[name] !== undefined) {
        name = prefix + name;
      }
      return name;
    }
  }, {
    key: 'match',
    value: function match(key, patterns) {
      if (patterns === undefined) {
        return true;
      } else if (Array.isArray(patterns)) {
        var length = patterns.length;
        var i = void 0;
        var pass = false;
        for (i = 0; i < length; ++i) {
          var pattern = patterns[i];
          if ((typeof pattern === 'undefined' ? 'undefined' : _typeof(pattern)) === 'object' && pattern.constructor !== undefined && pattern.constructor.name === 'RegExp') {
            pass = pass || pattern.test(key);
          }
        }
        return pass;
      } else if ((typeof patterns === 'undefined' ? 'undefined' : _typeof(patterns)) === 'object' && patterns.constructor !== undefined && patterns.constructor.name === 'RegExp') {
        return patterns.test(key);
      } else {
        return true;
      }
    }
  }, {
    key: 'notmatch',
    value: function notmatch(key, patterns) {
      if (patterns === undefined) {
        return true;
      } else if (Array.isArray(patterns)) {
        var length = patterns.length;
        var i = void 0;
        var pass = false;
        for (i = 0; i < length; ++i) {
          var pattern = patterns[i];
          if ((typeof pattern === 'undefined' ? 'undefined' : _typeof(pattern)) === 'object' && pattern.constructor !== undefined && pattern.constructor.name === 'RegExp') {
            pass = pass || pattern.test(key);
          }
        }
        return !pass;
      } else if ((typeof patterns === 'undefined' ? 'undefined' : _typeof(patterns)) === 'object' && patterns.constructor !== undefined && patterns.constructor.name === 'RegExp') {
        return !patterns.test(key);
      } else {
        return true;
      }
    }
  }, {
    key: 'defaultPatterns',
    get: function get() {
      return new _Patterns2.default(undefined, /^_.*$/, true);
    }
  }]);

  return Ely;
}();

exports.default = Ely;